unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math {pro generovn RandomRange};

type
  TForm1 = class(TForm)
    pnl_menu: TPanel;
    pbx: TPaintBox;
    btn_konec: TButton;
    pnl_clr: TPanel;
    clr_dlg: TColorDialog;
    chk_box: TCheckBox;
    pnl_clrbg: TPanel;
    lbl_err: TLabel;
    procedure btn_konecClick(Sender: TObject);
    procedure pnl_clrClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pbxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{$M $00004000, $09000000}          // zvetseni stacku aby zvladl rekurz.volani


function Bod(Puv:Integer):TPoint;
begin
      Bod.X:=RandomRange(Puv,Form1.ClientWidth);    //generovni X souradnic bodu
      Bod.Y:=RandomRange(Puv,Form1.ClientHeight);    //generovni Y souradnic bodu
end;

procedure seminko(x:LONGLONG; y:LONGLONG);
begin
  if (Form1.pbx.Canvas.pixels[x,y] = Form1.pnl_clrbg.Color) AND
    (Form1.pbx.Canvas.pixels[x,y] <> Form1.pnl_clr.Color)
   then
    begin
      Form1.pbx.Canvas.Pixels[x,y]:= Form1.pnl_clr.Color;
      if x<Form1.ClientWidth then seminko(x+1,y);
      if x>0 then seminko(x-1,y);
      if y>0 then seminko(x,y-1);
      if y<Form1.ClientHeight then seminko(x,y+1);
    end;
   if (Form1.pbx.Canvas.pixels[x,y] = Form1.pnl_clrbg.Color) AND
    (Form1.pbx.Canvas.pixels[x,y] = Form1.pnl_clr.Color)
   then Form1.lbl_err.Caption:='Nelze pekreslovat stejnou barvu';
end;

procedure seminko2(x:Integer; y:Integer);
begin
  if (Form1.pbx.Canvas.pixels[x,y] = Form1.pnl_clrbg.Color) AND
    (Form1.pbx.Canvas.pixels[x,y] <> Form1.pnl_clr.Color)
   then
    begin
      Form1.pbx.Canvas.Pixels[x,y]:= Form1.pnl_clr.Color;
      if Form1.pbx.Canvas.pixels[x+1,y]= Form1.pnl_clrbg.Color then seminko2(x+1,y);
      if Form1.pbx.Canvas.pixels[x-1,y]= Form1.pnl_clrbg.Color then seminko2(x-1,y);
      if Form1.pbx.Canvas.pixels[x,y-1]= Form1.pnl_clrbg.Color then seminko2(x,y-1);
      if Form1.pbx.Canvas.pixels[x,y+1]= Form1.pnl_clrbg.Color then seminko2(x,y+1);
    end;
   if (Form1.pbx.Canvas.pixels[x,y] = Form1.pnl_clrbg.Color) AND
    (Form1.pbx.Canvas.pixels[x,y] = Form1.pnl_clr.Color)
   then Form1.lbl_err.Caption:='Nelze pekreslovat stejnou barvu';
end;

procedure TForm1.btn_konecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.pnl_clrClick(Sender: TObject);
begin
  clr_dlg.Color := pnl_clr.Color;
  if(clr_dlg.Execute) then
    begin
      pnl_clr.Color := clr_dlg.Color;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  pnl_clr.Color := clGreen;
  pbx.Canvas.Pen.Color:=clRed;
end;

procedure TForm1.pbxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lbl_err.Caption:='';
  if (chk_box.Checked = true) AND (Button <> mbMiddle) then
    begin
      Form1.pnl_clrbg.Color := Form1.pbx.Canvas.Pixels[X,Y];
      seminko(X,Y);
      //seminko2(X,Y);
    end
  else
    begin
    if Button = mbLeft then
      begin
          pbx.Canvas.Rectangle(X,Y, Bod(X).X, Bod(Y).Y);
      end;
    if Button = mbRight then
      begin
        pbx.Canvas.Ellipse(X,Y,Bod(X).X, Bod(Y).Y);
      end;
    if Button = mbMiddle then
      begin
        if(chk_box.Checked = true) then
          chk_box.Checked:= false
        else chk_box.Checked:= true;
      end;
    end;
end;

end.
