unit ipogr_01_03_ahoj_svete_ext;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    Soubor1: TMenuItem;
    Npovda1: TMenuItem;
    Oaplikaci1: TMenuItem;
    Npovda2: TMenuItem;
    Ukonit1: TMenuItem;
    GB_nasatveni: TGroupBox;
    Lbl_MainText: TLabel;
    Btn_font: TButton;
    Dlg_Font: TFontDialog;
    Dlg_Color: TColorDialog;
    Btn_Color: TButton;
    GB_align: TGroupBox;
    RB_left: TRadioButton;
    RB_center: TRadioButton;
    RB_right: TRadioButton;
    Edt_Input_Text: TEdit;
    Btn_ReText: TButton;
    GB_text: TGroupBox;
    CBox_versale: TCheckBox;
    CBox_bytyping: TCheckBox;
    Uloit1: TMenuItem;
    Nast1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure Ukonit1Click(Sender: TObject);
    procedure Btn_fontClick(Sender: TObject);
    procedure Btn_ColorClick(Sender: TObject);
    procedure Oaplikaci1Click(Sender: TObject);
    procedure RB_leftClick(Sender: TObject);
    procedure RB_centerClick(Sender: TObject);
    procedure RB_rightClick(Sender: TObject);
    procedure Edt_Input_TextClick(Sender: TObject);
    procedure Btn_ReTextClick(Sender: TObject);
    procedure Edt_Input_TextChange(Sender: TObject);
    procedure Edt_Input_TextKeyPress(Sender: TObject; var Key: Char);
    procedure Npovda2Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Nast1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Types, StrUtils;

{$R *.dfm}

procedure TForm1.Ukonit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Btn_fontClick(Sender: TObject);
begin
  Dlg_Font.Font := Lbl_MainText.Font;
  if Dlg_Font.Execute then
    Lbl_MainText.Font := Dlg_Font.Font;
end;

procedure TForm1.Btn_ColorClick(Sender: TObject);
begin
  Dlg_Color.Color := Lbl_MainText.Font.Color;
  if Dlg_Color.Execute then
    Lbl_MainText.Font.Color := Dlg_Color.Color;
end;

procedure TForm1.Oaplikaci1Click(Sender: TObject);
begin
  MessageDlg('Tak tady to u mi dalo docela zabrat'#10'http://fei.trtkal.net'#10'(c) Trtkal 2008',mtInformation, [mbOK], 0)
end;

procedure TForm1.RB_leftClick(Sender: TObject);
begin
  Lbl_MainText.Alignment:=taLeftJustify;
end;

procedure TForm1.RB_centerClick(Sender: TObject);
begin
  Lbl_MainText.Alignment:=taCenter;
end;

procedure TForm1.RB_rightClick(Sender: TObject);
begin
  Lbl_MainText.Alignment:=taRightJustify;
end;

procedure TForm1.Edt_Input_TextClick(Sender: TObject);
begin
  Edt_Input_Text.Text:='';
end;

procedure TForm1.Btn_ReTextClick(Sender: TObject);
begin
  Lbl_MainText.Caption := Edt_Input_Text.Text;
end;

procedure TForm1.Edt_Input_TextChange(Sender: TObject);
begin
  if CBox_bytyping.Checked
    then Lbl_MainText.Caption:=Edt_Input_Text.Text;
end;

procedure TForm1.Edt_Input_TextKeyPress(Sender: TObject; var Key: Char);
begin
  if CBox_versale.Checked
    then Key:=UpCase(Key);
end;

procedure TForm1.Npovda2Click(Sender: TObject);
begin
  MessageDlg('Nedlejte si ze mne srandu,'#13'e k tomuhle potebujete npovdu',mtWarning,[mbOk], 0);
end;

procedure TForm1.Uloit1Click(Sender: TObject);
var f:String;
begin
  if(SaveDialog1.Execute) then
   // f:=OpenDialog1.FileName;
   // Write(f, Lbl_MainText.Caption);
   MessageDlg('Sorry, but not implemented', mtWarning, [mbOK], 0);
end;

procedure TForm1.Nast1Click(Sender: TObject);
begin
  if(OpenDialog1.Execute) then
   MessageDlg('Sorry, but not implemented', mtWarning, [mbOK], 0);    
end;

end.
