unit ipogr_02_01a;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Btn_Ukoncit: TButton;
    Btn_Nacist: TButton;
    PObrazek: TPanel;
    OpenPictureDialog: TOpenPictureDialog;
    Obr_Image: TImage;
    PMenu: TPanel;
    Chbox_Resize: TCheckBox;
    Chbox_Centered: TCheckBox;
    Chbox_preserve_size: TCheckBox;
    procedure Btn_UkoncitClick(Sender: TObject);
    procedure Btn_NacistClick(Sender: TObject);
    procedure Chbox_ResizeClick(Sender: TObject);
    procedure Chbox_CenteredClick(Sender: TObject);
    procedure Chbox_preserve_sizeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Btn_UkoncitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Btn_NacistClick(Sender: TObject);
begin
  if OpenPictureDialog.Execute
    then Obr_Image.Picture.LoadFromFile(OpenPictureDialog.FileName);


end;

procedure TForm1.Chbox_ResizeClick(Sender: TObject);
begin
  Obr_Image.Stretch := Chbox_Resize.Checked;
end;

procedure TForm1.Chbox_CenteredClick(Sender: TObject);
begin
  Obr_Image.Center := Chbox_Centered.Checked;
end;

procedure TForm1.Chbox_preserve_sizeClick(Sender: TObject);
begin
  Obr_Image.Proportional := Chbox_preserve_size.Checked;
end;

end.
