unit ipogr_02_01b;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ExtDlgs, Menus;

type
  TForm1 = class(TForm)
    Btn_Ukoncit: TButton;
    Btn_Nacist: TButton;
    PObrazek: TPanel;
    OpenPictureDialog: TOpenPictureDialog;
    Obr_Image: TImage;
    PMenu: TPanel;
    Chbox_Resize: TCheckBox;
    Chbox_Centered: TCheckBox;
    Chbox_preserve_size: TCheckBox;
    MainMenu1: TMainMenu;
    Men_Soubor: TMenuItem;
    Nast1: TMenuItem;
    Konec1: TMenuItem;
    Men_nast: TMenuItem;
    nast_Resize: TMenuItem;
    nast_centered: TMenuItem;
    nast_preserve_size: TMenuItem;
    Oaplikaci1: TMenuItem;
    procedure Btn_UkoncitClick(Sender: TObject);
    procedure Btn_NacistClick(Sender: TObject);
    procedure Chbox_ResizeClick(Sender: TObject);
    procedure Chbox_CenteredClick(Sender: TObject);
    procedure Chbox_preserve_sizeClick(Sender: TObject);
    procedure Oaplikaci1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Nast1Click(Sender: TObject);
    procedure nast_centeredClick(Sender: TObject);
    procedure nast_preserve_sizeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CurrentDir : String; //aktuln adres
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Btn_UkoncitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Btn_NacistClick(Sender: TObject);
begin
  if OpenPictureDialog.Execute
    then Obr_Image.Picture.LoadFromFile(OpenPictureDialog.FileName);
end;

procedure TForm1.Chbox_ResizeClick(Sender: TObject);
begin
  Obr_Image.Stretch := Chbox_Resize.Checked;
  nast_Resize.Checked := Chbox_Resize.Checked;
end;

procedure TForm1.Chbox_CenteredClick(Sender: TObject);
begin
  Obr_Image.Center := Chbox_Centered.Checked;
  nast_centered.Checked := Chbox_Centered.Checked;
end;

procedure TForm1.Chbox_preserve_sizeClick(Sender: TObject);
begin
  Obr_Image.Proportional := Chbox_preserve_size.Checked;
  nast_preserve_size.Checked := Chbox_preserve_size.Checked;
end;

procedure TForm1.Oaplikaci1Click(Sender: TObject);
begin
  MessageDlg('Trtkalv mega nejlep prohle obrzk :D'#13'http://fei.trtkal.net'#13'(c) Trtkal 2008', mtInformation, [mbYes], 0);
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
  Btn_UkoncitClick(Self);
end;

procedure TForm1.Nast1Click(Sender: TObject);
begin
  Btn_NacistClick(Self);
end;

procedure TForm1.nast_centeredClick(Sender: TObject);
begin
  Obr_Image.Center := Chbox_Centered.Checked;
  nast_centered.Checked := Chbox_Centered.Checked;
end;

procedure TForm1.nast_preserve_sizeClick(Sender: TObject);
begin
  Obr_Image.Proportional := Chbox_preserve_size.Checked;
  nast_preserve_size.Checked := Chbox_preserve_size.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  GetDir(0, CurrentDir); //0 = defaultn disk - nate hodnotu aktulnho adrese (nevyuito :D)
  OpenPictureDialog.InitialDir:='C:\windows\system32'; // piad natacmu formuli hodnotu z CurrnetDir
  end;

end.
