unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ExtDlgs;

type
  Tfrm_main = class(TForm)
    pnl_ovladani: TPanel;
    btn_konec: TButton;
    pbox: TPaintBox;
    btn_pozadi: TButton;
    btn_domek: TButton;
    btn_orel: TButton;
    procedure btn_konecClick(Sender: TObject);
    procedure btn_pozadiClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btn_orelClick(Sender: TObject);
    procedure btn_domekClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frm_main: Tfrm_main;

implementation

uses Types;

{$R *.dfm}

procedure Tfrm_main.btn_konecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure Tfrm_main.btn_pozadiClick(Sender: TObject);
var
  Bitmap : TBitmap;
begin
  Bitmap := TBitmap.Create;
  Bitmap.LoadFromFile('./Nebe.bmp');
  ClientWidth:=Bitmap.Width;
  ClientHeight:=Bitmap.Height;
  Canvas.Draw(0,0,Bitmap);  
end;

procedure Tfrm_main.FormCreate(Sender: TObject);
begin
  Left:= 20;
  Top:= 20;
  Width:= 400;
  Height:=400;
end;

procedure Tfrm_main.btn_orelClick(Sender: TObject);
var
  Bitmap:TBitmap;
begin
  Bitmap:=TBitmap.Create;

  try //zachytvn vjimek
    Bitmap.LoadFromFile('./orel_maly.bmp');
    Bitmap.Transparent:=True; // zapnut transparentnosti
    Bitmap.TransparentColor:=Bitmap.Canvas.Pixels[0,0]; // vezme prhlednost podle barvy pizexu na pozici
    //Bitmap.TransparentColor:=RGB(255,255,255); // nasatven abrvy transparentnosti
      //monost nastavit teba: clWhite, clXXX
    Canvas.Draw(50, 210,Bitmap);
  finally
    Bitmap.Free;
  end;

end;

procedure Tfrm_main.btn_domekClick(Sender: TObject);
var
  bitmap1, bitmap2: TBitmap;
  dum, komin, okno, dvere: TRect;
  strecha: array[0..2] of TPoint;
  r: integer;
  tmpPenColor, tmpBrushColor : TColor;
  tmpBrushStyle: TBrushStyle;
begin
  with dum do begin
    Left:= 280;
    Top:= 300;
    Right:=530;
    Bottom:= 450;
  end;

  with komin do begin
    Left:= dum.Left + 180;
    Top:= dum.Top -90;
  end;

end;

end.
