unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin;

type
  Tfrm_main = class(TForm)
    pnl_menu: TPanel;
    btn_konec: TButton;
    lbl_position: TLabel;
    bvl_souradnice: TBevel;
    clrdlg_color: TColorDialog;
    clrdlg_bg: TColorDialog;
    spe_size: TSpinEdit;
    lbl_size: TLabel;
    pnl_color: TPanel;
    pnl_bg: TPanel;
    lbl_cara: TLabel;
    lbl_bg: TLabel;
    procedure btn_konecClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure pnl_colorClick(Sender: TObject);
    procedure pnl_bgClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frm_main: Tfrm_main;

implementation

{$R *.dfm}

procedure Tfrm_main.btn_konecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure Tfrm_main.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  lbl_position.Caption:='Souadnice: ' + IntToStr(X) + ':'+ IntToStr(Y);
end;

procedure Tfrm_main.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Canvas.Pen.Color:=pnl_color.Color;
  Canvas.Brush.Color:=pnl_bg.Color;

  if Button = mbleft then
    Canvas.Rectangle(X,Y,X+spe_size.Value,Y+spe_size.Value)
    else
      if Button = mbright then
        Canvas.Ellipse(X,Y,X+spe_size.Value,Y+spe_size.Value);
end;

procedure Tfrm_main.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  spe_size.Value:=spe_size.Value-1;
end;

procedure Tfrm_main.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  spe_size.Value:=spe_size.Value+1;
end;

procedure Tfrm_main.FormCreate(Sender: TObject);
begin
  spe_size.Value:= 33;
  frm_main.Color:= RGB(22,22,22);
  Canvas.Pen.Width:= 3; // tlouka ormovn 
end;

procedure Tfrm_main.pnl_colorClick(Sender: TObject);
begin
  clrdlg_color.Color := pnl_color.Color;
  if(clrdlg_color.Execute) then
    pnl_color.Color:=clrdlg_color.Color;
end;

procedure Tfrm_main.pnl_bgClick(Sender: TObject);
begin
  clrdlg_bg.Color := pnl_bg.Color;
  if(clrdlg_bg.Execute) then
    pnl_bg.Color:=clrdlg_bg.Color;
end;

end.
