unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Math {pro generovn RandomRange};

type
  TForm1 = class(TForm)
    pnl_menu: TPanel;
    btn_konec: TButton;
    btn_start: TButton;
    btn_stop: TButton;
    PB_Kresleni: TPaintBox;
    procedure btn_konecClick(Sender: TObject);
    procedure btn_stopClick(Sender: TObject);
    procedure btn_startClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  KonecKresleni:boolean;
  LH,PD, Bod: TPoint;

implementation

{$R *.dfm}

function LeziVPravouhelniku(Bod, LH, PD : TPoint) : boolean; // zjist, jeslti le v oblasti tyhelnku
begin
  if((Bod.X >= LH.X) AND (Bod.X <= PD.X) AND (Bod.Y >= LH.Y) AND (Bod.Y <= PD.Y)) // ov, jestli je bod v tyhelnku
    then  LeziVPravouhelniku:=True // pokud ano, tak vrt hodnotu True
    else  LeziVPravouhelniku:=False; // pokud ne, tak vrt hodnotu False
end;

function JeBodVPravOblasti (Bod, LH, PD : TPoint)  : boolean; // oven, zda-li bod le v oblasti
begin
  KonecKresleni:=false; //nastav KonecKreslen na NEPravda
  repeat
    Bod.X:=RandomRange(0,Form1.PB_Kresleni.Width);    //generovni X souradnic bodu
    Bod.Y:=RandomRange(0,Form1.PB_Kresleni.Width);    //generovni Y souradnic bodu
    if LeziVPravouhelniku(Bod,LH,PD) //pokud LezBodVtuhelnku
      then Form1.PB_Kresleni.Canvas.Pixels[Bod.x, Bod.y]:=clRed // vybarvi erven
      else Form1.PB_Kresleni.Canvas.Pixels[Bod.x, Bod.y]:=clBlue; // jinak vybarvi mod
    Application.ProcessMessages; // zkontroluje, jestli se nezmklo tlatko STOP
  until KonecKresleni; // ukon, pokud KonecKreslen je Pravda
end;

procedure GenerujUhelnik(); //vygeneruje obrazec
begin
  LH.X:=RandomRange(0,Form1.PB_Kresleni.Width);    //generovni X souradnic Horn roh
  LH.Y:=RandomRange(0,Form1.PB_Kresleni.Height);    //generovni Y souradnic Horn roh
  PD.X:=RandomRange(LH.X+10,Form1.PB_Kresleni.Width);    //generovni X souradnic Doln roh
  PD.Y:=RandomRange(LH.Y+10,Form1.PB_Kresleni.Height);    //generovni Y souradnic Doln roh
end;

procedure TForm1.btn_konecClick(Sender: TObject);
begin
  Application.Terminate; // ukonen aplikace
end;

procedure TForm1.btn_stopClick(Sender: TObject);
begin
  KonecKresleni:=True; // pokud se klikne na Stop, nastav KonecKreslen na Pravda
end;

procedure TForm1.btn_startClick(Sender: TObject);
begin
  GenerujUhelnik(); // zavol funkci na generovn tyuhelnku
  Bod.X:=0; // nastav njak X poten souadnice prvnho bodu
  Bod.Y:=0; // nastav njak Y poten souadnice prvnho bodu
  JeBodVPravOblasti(Bod, LH, PD); // zavol funkci, kter vybarvuje
  KonecKresleni:=False; //nasatvme, e nen konc kreslen
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize; // pseudonhodn generovn sel (nen poteba, ale m vt nhodnost)
end;

end.
